- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sbuild::auth_conv Class Reference

Authentication conversation handler interface. More...

`#include <sbuild-auth-conv.h>`

Inheritance diagram for sbuild::auth_conv:

[legend]
List of all members.

## Public Types
typedef std::vector< auth_message > | message_list
| A list of messages.
## Public Member Functions
| auth_conv ()
| The constructor.
virtual | ~auth_conv ()
| The destructor.
virtual time_t | get_warning_timeout ()=0
| Get the time at which the user will be warned.
virtual void | set_warning_timeout (time_t timeout)=0
| Set the time at which the user will be warned.
virtual time_t | get_fatal_timeout ()=0
| Get the time at which the conversation will be terminated with an error.
virtual void | set_fatal_timeout (time_t timeout)=0
| Set the time at which the conversation will be terminated with an error.
virtual void | conversation (message_list &messages)=0
| Hold a conversation with the user.

## Detailed Description

Authentication conversation handler interface.

This interface should be implemented by objects which handle interaction with the user during authentication.

This is a wrapper around the struct pam_conv PAM conversation interface, and is used by auth when interacting with the user during authentication.

A simple implementation is provided in the form of auth_conv_tty. However, more complex implementations might hook into the event loop of a GUI widget system, for example.

The interface allows the setting of optional warning timeout and fatal timeout values, which should default to 0 (not enabled). This is an absolute time after which a warning is displayed or the conversation ends with an error.

## Member Typedef Documentation

typedef std::vector<auth_message> sbuild::auth_conv::message_list

A list of messages.

## Constructor & Destructor Documentation

auth_conv::auth_conv | ( |  | ) |

The constructor.

auth_conv::~auth_conv | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

virtual void sbuild::auth_conv::conversation | ( | message_list & | messages | ) | `[pure virtual]`

Hold a conversation with the user.

Each of the messages detailed in messages should be displayed to the user, asking for input where required. The type of message is indicated in the auth_message::type field of the auth_message. The auth_message::response field of the auth_message should be filled in if input is required.

On error, an exception will be thrown.

Parameters:

  | messages | the messages to display to the user, and responses to return to the caller.

Implemented in sbuild::auth_conv_tty.

virtual time_t sbuild::auth_conv::get_fatal_timeout | ( |  | ) | `[pure virtual]`

Get the time at which the conversation will be terminated with an error.

Returns:
  the time.

Implemented in sbuild::auth_conv_tty.

virtual time_t sbuild::auth_conv::get_warning_timeout | ( |  | ) | `[pure virtual]`

Get the time at which the user will be warned.

Returns:
  the time.

Implemented in sbuild::auth_conv_tty.

virtual void sbuild::auth_conv::set_fatal_timeout | ( | time_t | timeout | ) | `[pure virtual]`

Set the time at which the conversation will be terminated with an error.

Parameters:

  | timeout | the time to set.

Implemented in sbuild::auth_conv_tty.

virtual void sbuild::auth_conv::set_warning_timeout | ( | time_t | timeout | ) | `[pure virtual]`

Set the time at which the user will be warned.

Parameters:

  | timeout | the time to set.

Implemented in sbuild::auth_conv_tty.

The documentation for this class was generated from the following files:

- sbuild/sbuild-auth-conv.h
- sbuild/sbuild-auth-conv.cc